//If the include does not work then the contents of the ranluxcl.cl file can just be
//pasted here at the top instead.
#include "ranluxcl.cl"

__kernel void Kernel_PRN(private int KernelCycles,
                         global float4* RANLUXCLTab,
                         global float* PRNs)
{
	//Downloading RANLUXCLTab. The state of RANLUXCL is stored in ranluxclstate.
	ranluxcl_state_t ranluxclstate;
	ranluxcl_download_seed(&ranluxclstate, RANLUXCLTab);

	float4 randomnr;

	//Generate some numbers
	for(int i=0; i<KernelCycles; i+=4)
		randomnr = ranluxcl(&ranluxclstate);

	//Uploading only last number generated.
	PRNs[get_global_id(0)] = randomnr.w;

	//Uploading RANLUXCLTab
	ranluxcl_upload_seed(&ranluxclstate, RANLUXCLTab);
}
